
#include <windows.h>
#include <tchar.h>

#define VBOXMRXNP _T("VBoxMRXNP.dll")

BOOL IsFileExist(TCHAR* path)
{
	HANDLE fileHandle = CreateFile(path,GENERIC_READ, FILE_SHARE_READ|FILE_SHARE_WRITE|FILE_SHARE_DELETE,
		NULL,OPEN_EXISTING,0,NULL);

	if (fileHandle != INVALID_HANDLE_VALUE)
	{
		CloseHandle(fileHandle);
		return TRUE;
	}

	return FALSE;
}

int _tmain(int argc, TCHAR* argv[])
{
	TCHAR path[MAX_PATH+1];

	GetWindowsDirectory(path,sizeof(path));
	_tcscat(path,_T("\\SysWOW64\\") VBOXMRXNP);

	if (IsFileExist(path))
	{
		_tprintf(_T("System already patched!\n"));
		return 1;
	}

	_tprintf(_T("System was not patched, try to patch\n"));
	
	TCHAR vboxmrxnp32Path[MAX_PATH+1];
	GetModuleFileName(NULL,vboxmrxnp32Path,sizeof(vboxmrxnp32Path));

	for (int i=_tcslen(vboxmrxnp32Path); i>=0; i--)
	{
		if (vboxmrxnp32Path[i] == '\\')
		{
			vboxmrxnp32Path[i+1] = 0;
			break;
		}
	}

	_tcscat(vboxmrxnp32Path,VBOXMRXNP);
	if (!IsFileExist(vboxmrxnp32Path))
	{
		_tprintf(_T("ERROR: cannot patch because VBoxMRXNP.dll x86 not found in current directory!\n"));
		return -1;
	}

	if (!CopyFile(vboxmrxnp32Path, path, TRUE))
	{
		_tprintf(_T("ERROR: cannot copy file from '%s' to '%s'\n"),vboxmrxnp32Path,path);
	}
	else
	{
		_tprintf(_T("Patch OK!\n"));
	}

	return 0;
}